require 'extensions.rb'
require 'LangHandler.rb'

Dir.chdir Sketchup.find_support_file("Plugins")

# Extension Manager
$uStrings = LanguageHandler.new("Layer manager")
Layer_Manager_Extension = SketchupExtension.new $uStrings.GetString("Layer Manager"), "Layer Manager/layer_manager_v6.rb"
Layer_Manager_Extension.description=$uStrings.GetString("Manage your layers and layers configs.")
Layer_Manager_Extension.name= "Layer manager"
Layer_Manager_Extension.creator = "Didier Bur"
Layer_Manager_Extension.copyright = "12.2007, CRAI - Didier Bur"
Layer_Manager_Extension.version = "2.0 upgrade for GSU v6"

Sketchup.register_extension Layer_Manager_Extension, true

# Run
def exec_on_autoload
  puts("Layer Manager loaded.")
end

#-----------------------------------------------------------------------------------------------------
#                                        MENU ITEMS
#-----------------------------------------------------------------------------------------------------

if( not $layer_manager_menu_loaded )
  
  #Layers toolbar
  #------------------
  layers_tb = UI::Toolbar.new("Layer Manager")
  
  # Set layer of current selection as current layer
  cmd0 = UI::Command.new(("Set layer of selection current")) { (lm_set_current) }
  cmd0.small_icon = "Layer Manager/Calques_selection_courant_Small.png"
  cmd0.large_icon = "Layer Manager/Calques_selection_courant_Large.png"
  cmd0.tooltip = "Set layer of selection current"
  layers_tb.add_item(cmd0)
  
  # move selection to current layer
  cmd00 = UI::Command.new(("Move selection to current layer")) { (lm_selection_to_current) }
  cmd00.small_icon = "Layer Manager/Calques_selection_vers_courant_Small.png"
  cmd00.large_icon = "Layer Manager/Calques_selection_vers_courant_Large.png"
  cmd00.tooltip = "Move selection to current layer"
  layers_tb.add_item(cmd00)
  
  layers_tb.add_separator
  
  #Display layer config
  cmd1 = UI::Command.new(("Display layers config")) { (lm_display_config) }
  cmd1.small_icon = "Layer Manager/Config_calques_afficher_Small.png"
  cmd1.large_icon = "Layer Manager/Config_calques_afficher_Large.png"
  cmd1.tooltip = "Display layer config"
  layers_tb.add_item(cmd1)
  
  #Save layer config in SKP
  cmd3 = UI::Command.new(("Save layers config")) { (lm_save_layers_config_skp) }
  cmd3.small_icon = "Layer Manager/Config_calques_enregistrer_Small.png"
  cmd3.large_icon = "Layer Manager/Config_calques_enregistrer_Large.png"
  cmd3.tooltip = "Save layers config"
  layers_tb.add_item(cmd3)
  
  #Restore layer config from SKP
  cmd2 = UI::Command.new(("Restore layers config")) { (lm_load_layers_config_skp) }
  cmd2.small_icon = "Layer Manager/Config_calques_charger_Small.png"
  cmd2.large_icon = "Layer Manager/Config_calques_charger_Large.png"
  cmd2.tooltip = "Restore layers config"
  layers_tb.add_item(cmd2)
  
  #Restore layer config from SKP - Show only
  cmd21 = UI::Command.new(("Restore layers config - Show only")) { (lm_load_layers_config_skp_show_only) }
  cmd21.small_icon = "Layer Manager/Config_calques_chargerso_Small.png"
  cmd21.large_icon = "Layer Manager/Config_calques_chargerso_Large.png"
  cmd21.tooltip = "Restore layers config - Show only"
  layers_tb.add_item(cmd21)
  
  #Restore layer config from SKP - Append
  cmd211 = UI::Command.new(("Restore layers config - Append")) { (lm_load_layers_config_skp_append) }
  cmd211.small_icon = "Layer Manager/Config_calques_chargerap_Small.png"
  cmd211.large_icon = "Layer Manager/Config_calques_chargerap_Large.png"
  cmd211.tooltip = "Restore layers config - Append"
  layers_tb.add_item(cmd211)
  
  #Save layer config to file
  cmd31 = UI::Command.new(("Save layers configs to file")) { (lm_save_layers_config_file) }
  cmd31.small_icon = "Layer Manager/Config_calques_enregistrerf_Small.png"
  cmd31.large_icon = "Layer Manager/Config_calques_enregistrerf_Large.png"
  cmd31.tooltip = "Save layers configs to file"
  layers_tb.add_item(cmd31)
  
  #Restore layer config from file
  cmd2111 = UI::Command.new(("Restore layers configs from file")) { (lm_load_layers_config_file) }
  cmd2111.small_icon = "Layer Manager/Config_calques_chargerf_Small.png"
  cmd2111.large_icon = "Layer Manager/Config_calques_chargerf_Large.png"
  cmd2111.tooltip = "Restore layers configs from file"
  layers_tb.add_item(cmd2111)
  
  #Delete layer config
  cmd9 = UI::Command.new(("Delete layers config")) { (lm_delete_layers_config) }
  cmd9.small_icon = "Layer Manager/Config_calques_effacer_Small.png"
  cmd9.large_icon = "Layer Manager/Config_calques_effacer_Large.png"
  cmd9.tooltip = "Delete layers config"
  layers_tb.add_item(cmd9)
  
  layers_tb.add_separator
  
  #All layers visible
  cmd4 = UI::Command.new(("All layers visible")) { (lm_all_visible) }
  cmd4.small_icon = "Layer Manager/Calques_afficher_tous_Small.png"
  cmd4.large_icon = "Layer Manager/Calques_afficher_tous_Large.png"
  cmd4.tooltip = "All layers visible"
  layers_tb.add_item(cmd4)
  
  #All layers invisible
  cmd6 = UI::Command.new(("All layers invisible")) { (lm_all_invisible) }
  cmd6.small_icon = "Layer Manager/Calques_cacher_tous_Small.png"
  cmd6.large_icon = "Layer Manager/Calques_cacher_tous_Large.png"
  cmd6.tooltip = "All layers invisible (except current)"
  layers_tb.add_item(cmd6)
  
  #Isolate selection
  cmd5 = UI::Command.new(("Isolate layers of selection")) { (lm_isolate_selection) }
  cmd5.small_icon = "Layer Manager/Calques_isoler_selection_Small.png"
  cmd5.large_icon = "Layer Manager/Calques_isoler_selection_Large.png"
  cmd5.tooltip = "Isolate layers of selection"
  layers_tb.add_item(cmd5)
  
  #Hide selection
  cmd7 = UI::Command.new(("Hide layers of selection")) { (lm_hide_selection) }
  cmd7.small_icon = "Layer Manager/Calques_cacher_selection_Small.png"
  cmd7.large_icon = "Layer Manager/Calques_cacher_selection_Large.png"
  cmd7.tooltip = "Hide layers of selection"
  layers_tb.add_item(cmd7)
  
  #Invert all layers status
  cmd8 = UI::Command.new(("Invert visibility of all layers")) { (lm_invert) }
  cmd8.small_icon = "Layer Manager/Calques_inverser_Small.png"
  cmd8.large_icon = "Layer Manager/Calques_inverser_Large.png"
  cmd8.tooltip = "Invert visibility of all layers"
  layers_tb.add_item(cmd8)
  
  layers_tb.add_separator
  
  #Isolate using a filter string
  cmd9 = UI::Command.new(("Isolate layers by filter")) { (lm_filter("isolate")) }
  cmd9.small_icon = "Layer Manager/Calques_isoler_filtre_Small.png"
  cmd9.large_icon = "Layer Manager/Calques_isoler_filtre_Large.png"
  cmd9.tooltip = "Isolate layers by filter"
  layers_tb.add_item(cmd9)  
  
  #Add using a filter string
  cmd9 = UI::Command.new(("Show layers by filter")) { (lm_filter("show")) }
  cmd9.small_icon = "Layer Manager/Calques_ajouter_filtre_Small.png"
  cmd9.large_icon = "Layer Manager/Calques_ajouter_filtre_Large.png"
  cmd9.tooltip = "Show layers by filter"
  layers_tb.add_item(cmd9)
  
  #Hide using a filter string
  cmd10 = UI::Command.new(("Hide layers by filter")) { (lm_filter("hide")) }
  cmd10.small_icon = "Layer Manager/Calques_cacher_filtre_Small.png"
  cmd10.large_icon = "Layer Manager/Calques_cacher_filtre_Large.png"
  cmd10.tooltip = "Hide layers by filter"
  layers_tb.add_item(cmd10)
  
# End of load
$layer_manager_menu_loaded = true
end
file_loaded("layer_manager_v6.rb")
